﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ExcelDummy;

namespace IDisposableSample
{
	class Disposer : IDisposable
	{
		public TYPE Push<TYPE>( TYPE disp_obj ) where TYPE : IDisposable
		{
			_DispStack.Push( disp_obj );
			return disp_obj;
		}

		public void Dispose()
		{
			foreach( IDisposable disp_obj in _DispStack )
			{
				if( disp_obj != null ) disp_obj.Dispose();
			}
		}

		Stack<IDisposable> _DispStack = new Stack<IDisposable>();
	}

	class Program
	{
		static void Main( string[] args )
		{
			try
			{
				using( Disposer disp_stac = new Disposer() )
				{
					ExcelApp excel = disp_stac.Push( new ExcelApp() );
					BookCollection books = disp_stac.Push( excel.Books );
					Book book = disp_stac.Push( books.Open( null ) );
					SheetCollection sheets = disp_stac.Push( book.Sheets );
					Sheet sheet1 = disp_stac.Push( sheets[ 1 ] );
					Range range1_1 = disp_stac.Push( sheet1[ 1, 1 ] );

					range1_1.Value = "10";
					Console.WriteLine( "-->" + range1_1.Value );

					Sheet sheet2 = disp_stac.Push( sheets[ 2 ] );
					Range range2_3 = disp_stac.Push( sheet2[ 2, 3 ] );

					range2_3.Value = range1_1.Value;
					Console.WriteLine( "--->" + range2_3.Value );
				}
			}
			catch( Exception ex )
			{
				Console.WriteLine( "Exception: " + ex.Message );
			}
		}
	}
}
