﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ExcelDummy;

namespace IDisposableSample3
{
	class Program3
	{
		static void Main( string[] args )
		{
			try
			{
				using( ExcelApp excel = new ExcelApp() )
				using( BookCollection books = excel.Books )
				using( Book book = books.Open( "Book1.xls" ) )
				using( SheetCollection sheets = book.Sheets )
				using( Sheet sheet = sheets[ 1 ] )
				using( Range range1_1 = sheet[ 1, 1 ] )
				{
					range1_1.Value = "10";
					Console.WriteLine( "-->" + range1_1.Value );

					using( Sheet sheet2 = sheets[ 2 ] )
					using( Range range2 = sheet2[ 2, 3 ] )
					{
						range2.Value = range1_1.Value;
						Console.WriteLine( "-->" + range2.Value );
					}
				}
			}
			catch( Exception ex )
			{
				Console.WriteLine( ex.Message );
			}
		}

		static Range GetA1Range( ExcelApp excel )
		{
			BookCollection books = excel.Books;
			Book book = books.Open( "Book1.xls" );
			SheetCollection sheets = book.Sheets;
			Sheet sheet = sheets[ 1 ];
			return sheet[ 1, 1 ];
		}
	}
}

// Range を大量に扱うと大変なことになる
// IDisposable オブジェクトのスコープを考慮した関数を作らなければならない
