﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ExcelDummy;

namespace IDisposableSample4
{
	class Program4
	{
		static void Main( string[] args )
		{
			Stack<IDisposable> disp_stack = new Stack<IDisposable>();
			try
			{
				ExcelApp excel = new ExcelApp();
				disp_stack.Push( excel );

				BookCollection books = excel.Books;
				disp_stack.Push( books );

				Book book = books.Open( "Book1.xls" );
				disp_stack.Push( book );

				SheetCollection sheets = book.Sheets;
				disp_stack.Push( sheets );

				Sheet sheet = sheets[ 1 ];
				disp_stack.Push( sheet );

				Range range1_1 = sheet[ 1, 1 ];
				disp_stack.Push( range1_1 );

				range1_1.Value = "10";
				Console.WriteLine( "-->" + range1_1.Value );

				Sheet sheet2 = sheets[ 2 ];
				disp_stack.Push( sheet2 );

				Range range2_3 = sheet2[ 2, 3 ];
				disp_stack.Push( range2_3 );

				range2_3.Value = range1_1.Value;
				Console.WriteLine( "-->" + range2_3.Value );
			}
			catch( Exception ex )
			{
				Console.WriteLine( ex.Message );
			}
			finally
			{
				foreach( IDisposable disp_obj in disp_stack )
				{
					disp_obj.Dispose();
				}
			}
		}
	}
}

// Range を大量に扱っても問題なく処理できる
// オブジェクトのスコープ問題は解決していない
// いちいちPushするのは面倒
