﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ExcelDummy;

namespace IDisposableSample5
{
	class Disposer : IDisposable
	{
		public void Push( IDisposable disp_obj )
		{
			if( disp_obj != null )
			{
				_DispStack.Push( disp_obj );
			}
		}

		public void Dispose()
		{
			foreach( IDisposable disp_obj in _DispStack )
			{
				disp_obj.Dispose();
			}
		}

		Stack<IDisposable> _DispStack = new Stack<IDisposable>();
	}

	class Program5
	{
		static void Main( string[] args )
		{
			try
			{
				using( Disposer disp_stack = new Disposer() )
				{
					ExcelApp excel = new ExcelApp();
					disp_stack.Push( excel );

					BookCollection books = excel.Books;
					disp_stack.Push( books );

					Book book = books.Open( "Book1.xls" );
					disp_stack.Push( book );

					SheetCollection sheets = book.Sheets;
					disp_stack.Push( sheets );

					Sheet sheet = sheets[ 1 ];
					disp_stack.Push( sheet );

					Range range1_1 = sheet[ 1, 1 ];
					disp_stack.Push( range1_1 );

					range1_1.Value = "10";
					Console.WriteLine( "-->" + range1_1.Value );


					Sheet sheet2 = sheets[ 2 ];
					disp_stack.Push( sheet2 );

					Range range2_3 = sheet2[ 2, 3 ];
					disp_stack.Push( range2_3 );

					range2_3.Value = range1_1.Value;
					Console.WriteLine( "-->" + range2_3.Value );
				}
			}
			catch( Exception ex )
			{
				Console.WriteLine( ex.Message );
			}
		}
	}
}
