﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ExcelDummy;

namespace IDisposableSample6
{
	class Disposer : IDisposable
	{
		public TYPE Push<TYPE>( TYPE disp_obj ) where TYPE : IDisposable
		{
			if( disp_obj != null )
			{
				_DispStack.Push( disp_obj );
			}
			return disp_obj;
		}

		public void Dispose()
		{
			foreach( IDisposable disp_obj in _DispStack )
			{
				disp_obj.Dispose();
			}
		}

		Stack<IDisposable> _DispStack = new Stack<IDisposable>();
	}

	class Program6
	{
		static void Main( string[] args )
		{
			try
			{
				using( Disposer disp_stack = new Disposer() )
				{
					ExcelApp excel = disp_stack.Push( new ExcelApp() );
					BookCollection books = disp_stack.Push( excel.Books );
					Book book = disp_stack.Push( books.Open( "Book1.xls" ) );
					SheetCollection sheets = disp_stack.Push( book.Sheets );
					Sheet sheet = disp_stack.Push( sheets[ 1 ] );
					Range range1_1 = disp_stack.Push( sheet[ 1, 1 ] );

					range1_1.Value = "10";
					Console.WriteLine( "-->" + range1_1.Value );


					Sheet sheet2 = disp_stack.Push( sheets[ 2 ] );
					Range range2_3 = disp_stack.Push( sheet2[ 2, 3 ] );

					range2_3.Value = range1_1.Value;
					Console.WriteLine( "-->" + range2_3.Value );
				}
			}
			catch( Exception ex )
			{
				Console.WriteLine( ex.Message );
			}
		}
	}
}
